Subject: Re: [BUG] 2.6.29-rc* QinQ vlan trunking regression

From: Frank Blaschka <[email-masked]>
Date: Thu, 05 Mar 2009 09:05:42 +0100

Hi Dave, Patrick,

sorry I could not follow the complete discussion of the fixes done for this problem
but does

 	if (netif_device_present(real_dev) && ops->ndo_neigh_setup)
-		err = ops->ndo_neigh_setup(dev, pa);
+		err = ops->ndo_neigh_setup(real_dev, pa);

not change the idea of the neigh_setup? Remind we want the neigh_setup of the
real device as the neigh setup function for the vlan device.

Frank

Patrick McHardy schrieb:
> Patrick McHardy wrote:
>> David Miller wrote:
>>> From: Patrick McHardy <[email-masked]>
>>> Date: Thu, 05 Mar 2009 08:12:50 +0100
>>>
>>>>> We probably need both fixes to cover everything.
>>>>>
>>>> Yes, just the second one still crashes. I'm about to retry using both.
>>>
>>> Here is the updated version just for the record:
>>>
>>> vlan: Fix vlan-in-vlan crashes.
>>
>> This still crashes. I'll have another look at the code.
> 
> This one combined with your patch fixes the crash. The code was calling
> vlan_dev_neigh_setup recursively.
> 
> Signed-off-by: Patrick McHardy <[email-masked]>
> 
> (or Tested-by: in case you want to roll it into your patch).
>